<?php
/*
Plugin Name: Blog in Blog
Plugin URI: http://informationtakesover.co.uk/blog-in-blog-wordpress-plugin/
Description: Create a blog within a blog using a category. This plugin basically shows posts in a category on a page using shortcodes.
Version: 0.1
Author: Tim Hodson
Author URI: http://informationtakesover.co.uk
*/
/*  Copyright 2009  Tim Hodson  (email : tim@timhodson.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
 * [bloginblog category_id= num= ]
 * Assume most recent first (it's supposed to be a mini blog)
 */

function blog_in_blog_func($atts) {
	extract(shortcode_atts(array (
		'category_id' => '1',
		'num' => '10',


	), $atts));

	// get 10 posts for that category
	$out = "";
	$params = "numberposts=$num&orderby=date&order=DESC&category=$category_id";
	$postslist = get_posts($params);
	foreach ($postslist as $post) {

		$out .= '<div class="post">';
		$out .= '<!-- Post Headline -->		';
		$out .= '<div class="post-headline">';
		$out .= '<h2>';
		$out .= '<a title="Permanent Link to ' . $post->post_title . ' ' . apply_filters('the_date', $post->post_date_gmt) . '" rel="bookmark" href="';
		$out .= apply_filters('the_permalink', get_permalink($post)) . '" id="post-' . $post->ID . '" >';
		$out .= $post->post_title . '</a>';
		$out .= '</h2>';
		$out .= '</div>';
		$out .= '<!-- Post Body Copy -->';
		$out .= '<div class="post-bodycopy clearfix">';
		$out .= apply_filters('the_content', $post->post_content);
		$out .= '</div>	';
		$out .= '</div>	';

	}
	// return the posts data.
	return $out;
}
add_shortcode('blog_in_blog', 'blog_in_blog_func');

/*
 * Hide the category chosen to be the blog
 */

add_action('pre_get_posts', 'bib_hide_category' );

function bib_hide_category( $notused )
{
  global $wp_query;
  
  $cat = get_option('bib_hide_category');
  if( is_home() ) {
     $wp_query->query_vars['cat'] = '-' . $cat;
  }
}

// alternative way to hide categories from template page
  // if (is_home()) {
    //  query_posts("cat=-8");
   //}

/*
 * Add options to admin menu
 */

add_option('bib_hide_category');

add_action('admin_menu', 'blog_in_blog_menu');

function blog_in_blog_menu() {
	add_options_page('blog in blog Options', 'Blog-in-Blog', 8, __FILE__, 'blog_in_blog_options');
}

function blog_in_blog_options() {
	$out = "";
	$out .= '<div class="wrap">';
	$out .= '<h2>Blog-in-Blog</h2>';
	$out .= '<p>See full notes at <a href="http://informationtakesover.co.uk/blog-in-blog-wordpress-plugin/">http://informationtakesover.co.uk/blog-in-blog-wordpress-plugin/</a></p>';

	$out .= '<form method="post" action="options.php">';
	$out .= wp_nonce_field('update-options');

	$out .= '<table class="form-table">';

	$out .= '<tr valign="top">';
	$out .= '<th scope="row">Category id to hide from homepage</th>';

	$out .= '<td>';
	$params = 'name=bib_hide_category&selected='.get_option('bib_hide_category');
	$out .= wp_dropdown_categories($params);
	$out .= '</td>';
	$out .= '</tr>';

	$out .= '</table>';

	$out .= '<input type="hidden" name="action" value="update" />';
	$out .= '<input type="hidden" name="page_options" value="bib_hide_category" />';

	$out .= '<p class="submit">';
	$out .= '<input type="submit" class="button-primary" value="Save Changes" />';
	$out .= '</p>';

	$out .= '</form>';
	$out .= '</div>';

	echo $out;
}
?>
